/******************************************************************************
*                         ** Company Confidential **
*                  ** Copyright 1994, All rights Reserved **
* %Z%%M% version %I% date:%G%
******************************************************************************/

// -MQBeg- [Module_Includes] [ttteng_cc] <00000017.00000000> Retained!
#include "ttteng.h"
// -MQEnd- [Module_Includes] [ttteng_cc] <00000017.00000000> 

// -MQBeg- [Module_Declarations_1] [ttteng_cc] <00000017.00000000> Retained!
// -MQEnd- [Module_Declarations_1] [ttteng_cc] <00000017.00000000> 

// -MQBeg- [Class_Body] [TTT_Engine] <00000000.00000001> 
/******************************************************************************
                                  TTT_Engine
******************************************************************************/

const int TTT_Engine::freeMasks[] = {0x006,0x005,0x003,0x030,0x028,0x018,0x180,0x140,0x0c0,0x048,0x041,0x009,0x090,0x082,0x012,0x120,0x104,0x024,0x110,0x101,0x011,0x050,0x044,0x014};
const int TTT_Engine::winningMasks[] = {0x1c0,0x038,0x007,0x124,0x092,0x049,0x111,0x054};

TTT_Engine::TTT_Engine()
// -MQBeg- [Op_Init] [TTT_Engine::TTT_Engine] <0000002D.00000037> Retained!
// -MQEnd- [Op_Init] [TTT_Engine::TTT_Engine] <0000002D.00000037> 
{
// -MQBeg- [Op_Body] [TTT_Engine::TTT_Engine] <0000002D.00000037> Retained!
  this->Reset();
// -MQEnd- [Op_Body] [TTT_Engine::TTT_Engine] <0000002D.00000037> 
}

void
TTT_Engine::Reset()
{
// -MQBeg- [Op_Body] [TTT_Engine::Reset] <0000002D.00000038> Retained!
  MoveResult = LEGAL;
  this->ClearBoard();
// -MQEnd- [Op_Body] [TTT_Engine::Reset] <0000002D.00000038> 
}

int
TTT_Engine::MoveRequest(int CellNumber)
{
// -MQBeg- [Op_Body] [TTT_Engine::MoveRequest] <0000002D.00000039> Retained!
  if( (1 << CellNumber) & (UserBoard | CompBoard) )
    MoveResult = ILLEGAL;
  else
  { 
    UserBoard |= 1 << CellNumber;
    MoveResult = LEGAL;
    this->WinLoseDraw();      // Modify MoveResult if game is over.
    if (MoveResult == LEGAL)  // Game is not over.
    {
      this->ComputerTurn();
      this->WinLoseDraw();
    }  
  }
  return MoveResult;
// -MQEnd- [Op_Body] [TTT_Engine::MoveRequest] <0000002D.00000039> 
}

void
TTT_Engine::GetBoards(int& User, int& Comp)
{
// -MQBeg- [Op_Body] [TTT_Engine::GetBoards] <0000002D.0000003A> Retained!
  User = UserBoard;
  Comp = CompBoard;
// -MQEnd- [Op_Body] [TTT_Engine::GetBoards] <0000002D.0000003A> 
}

void
TTT_Engine::ComputerTurn(void)
{
// -MQBeg- [Op_Body] [TTT_Engine::ComputerTurn] <0000002D.0000003B> Retained!
  int MadeMove = 0;
  for( int i=0; i<24; i++)
  {
    if ((UserBoard & freeMasks[i]) == freeMasks[i])
    {
      int targetMask;
      FreeSquare(freeMasks[i], i, targetMask);
      if (CompBoard & targetMask)
         continue;
      CompBoard |= targetMask;
      MadeMove = 1;
      break;
    }
  }
  if(!MadeMove)  // Find first available location
  {
     if ( !((CompBoard|UserBoard) & 0x010) ) // See if middle is free
       CompBoard |= 0x010;
     else
     {
       int mask = UserBoard|CompBoard;
       for (int i=0; mask & 1; mask >>= 1) i++;
       if (i<9) CompBoard |= 1<<i;
     }
  }
// -MQEnd- [Op_Body] [TTT_Engine::ComputerTurn] <0000002D.0000003B> 
}

void
TTT_Engine::ClearBoard(void)
{
// -MQBeg- [Op_Body] [TTT_Engine::ClearBoard] <0000002D.0000003C> Retained!
  UserBoard = 0;
  CompBoard = 0;
// -MQEnd- [Op_Body] [TTT_Engine::ClearBoard] <0000002D.0000003C> 
}

void
TTT_Engine::FreeSquare(int Mask, int i , int& TargetMask)
{
// -MQBeg- [Op_Body] [TTT_Engine::FreeSquare] <0000002D.0000003D> Retained!
  int test1, mode = i/9;
  if (mode == 0)
    Mask ^= 0x007 << (i/3)*3;
  else if (mode == 1)
    Mask ^= 0x049 << ((i%9)/3);
  else if (((i%9)/3) == 0)
    Mask ^= 0x111;
  else
    Mask ^= 0x054;
  int j;
  for(j=0, test1=1; test1; test1 <<= 1, j++)
    if (test1 & Mask)
      break;
  TargetMask = 1 << j;
// -MQEnd- [Op_Body] [TTT_Engine::FreeSquare] <0000002D.0000003D> 
}

void
TTT_Engine::WinLoseDraw(void)
{
// -MQBeg- [Op_Body] [TTT_Engine::WinLoseDraw] <0000002D.0000003E> Retained!
  for(int i=0; i<8; i++)
  {
    if ((UserBoard & winningMasks[i]) == winningMasks[i])
    {
      MoveResult = YOUWIN;
      return;
    }
    else if ((CompBoard & winningMasks[i]) == winningMasks[i])
    {
      MoveResult = YOULOSE;
      return; 
    }
  }
  if ((UserBoard|CompBoard) == 0x1FF) MoveResult = DRAW;
// -MQEnd- [Op_Body] [TTT_Engine::WinLoseDraw] <0000002D.0000003E> 
}

// -MQEnd- [Class_Body] [TTT_Engine] <00000000.00000001> 

// -MQBeg- [Module_Declarations_2] [ttteng_cc] <00000017.00000000> Retained!
// -MQEnd- [Module_Declarations_2] [ttteng_cc] <00000017.00000000> 
